import { IgrFragmentBase } from "./igr-fragment-base";
import { AreaFragment } from "./AreaFragment";
/**
 * Represents one part of a StackedAreaSeries.
*/
export class IgrAreaFragment extends IgrFragmentBase {
    createImplementation() {
        return new AreaFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ev;
    }
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea() {
        return this.i.eu;
    }
}
