import { UnknownValuePlotting_$type } from "igniteui-react-core";
import { IgrPolarLineSeriesBase } from "./igr-polar-line-series-base";
import { PolarAreaSeries } from "./PolarAreaSeries";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents a IgxDataChartComponent polar area series.
*/
export class IgrPolarAreaSeries extends IgrPolarLineSeriesBase {
    createImplementation() {
        return new PolarAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea() {
        return this.i.eu;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.acv;
    }
    set unknownValuePlotting(v) {
        this.i.acv = ensureEnum(UnknownValuePlotting_$type, v);
    }
}
