/**
 * Provides information about the progressive load progress of the HighDensityScatterSeries.
*/
export class IgrProgressiveLoadStatusEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The current status from 0 to 100 of the progressive load.
    */
    get currentStatus() {
        return this.i.currentStatus;
    }
    set currentStatus(v) {
        this.i.currentStatus = +v;
    }
}
