/**
 * Provides data for the SelectedItemChanged event.
*/
export class IgrSelectedItemChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The previously selected item.
    */
    get oldItem() {
        return this.i.oldItem;
    }
    set oldItem(v) {
        this.i.oldItem = v;
    }
    /**
     * The newly selected item.
    */
    get newItem() {
        return this.i.newItem;
    }
    set newItem(v) {
        this.i.newItem = v;
    }
}
