import { SeriesViewerManipulationEventArgs as SeriesViewerManipulationEventArgs_internal } from "./SeriesViewerManipulationEventArgs";
import { ensureBool } from "igniteui-react-core";
export class IgrSeriesViewerManipulationEventArgs {
    createImplementation() {
        return new SeriesViewerManipulationEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get isZoomPan() {
        return this.i.isZoomPan;
    }
    set isZoomPan(v) {
        this.i.isZoomPan = ensureBool(v);
    }
    get isDragZoom() {
        return this.i.isDragZoom;
    }
    set isDragZoom(v) {
        this.i.isDragZoom = ensureBool(v);
    }
    get isDragSelect() {
        return this.i.isDragSelect;
    }
    set isDragSelect(v) {
        this.i.isDragSelect = ensureBool(v);
    }
}
