/**
 * Represents a calculation strategy that takes in a column of values
 * and returns a resulting column of values.
*/
var IgrColumnSupportingCalculation = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnSupportingCalculation() {
        this.mounted = false;
    }
    Object.defineProperty(IgrColumnSupportingCalculation.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnSupportingCalculation.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnSupportingCalculation.prototype.onImplementationCreated = function () {
    };
    IgrColumnSupportingCalculation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrColumnSupportingCalculation.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrColumnSupportingCalculation;
}());
export { IgrColumnSupportingCalculation };
