import { SeriesMatcher as SeriesMatcher_internal } from "./SeriesMatcher";
var IgrSeriesMatcher = /** @class */ /*@__PURE__*/ (function () {
    function IgrSeriesMatcher() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrSeriesMatcher.prototype.createImplementation = function () {
        return new SeriesMatcher_internal();
    };
    Object.defineProperty(IgrSeriesMatcher.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSeriesMatcher.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSeriesMatcher.prototype.onImplementationCreated = function () {
    };
    IgrSeriesMatcher.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrSeriesMatcher.prototype, "name", {
        /**
         * If set, tries to match a series based on its name.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSeriesMatcher.prototype, "title", {
        /**
         * If set, tries to match a series based on its title.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSeriesMatcher.prototype, "index", {
        /**
         * If set, tries to match a series based on index
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSeriesMatcher.prototype, "memberPathType", {
        /**
         * Combined with MemberPath allows you to select a series by member path.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSeriesMatcher.prototype, "memberPath", {
        /**
         * If set, tries to match a series based on a member path, combined with MemberPathType.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrSeriesMatcher.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrSeriesMatcher;
}());
export { IgrSeriesMatcher };
