import { Type } from "igniteui-react-core";
/**
 * Describes available locations of the x-axis labels in the chart.
 */
export declare enum AngleAxisLabelLocation {
    /**
     * Places the x-axis labels at the top, outside of the plotting area.
     */
    OutsideTop = 0,
    /**
     * Places the x-axis labels at the bottom, outside of the plotting area
     */
    OutsideBottom = 1,
    /**
     * Places the x-axis labels inside the plotting area above the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideTop = 2,
    /**
     * Places the x-axis labels inside the plotting area below the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideBottom = 3,
    /**
     * Places the x-axis labels based on the type of chart component.
     * Axis Labels Outside Bottom for all types of charts.
     */
    Auto = 4
}
/**
 * @hidden
 */
export declare let AngleAxisLabelLocation_$type: Type;
