import { Base, Type } from "igniteui-react-core";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Series } from "./Series";
import { Visibility } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { CalloutCollisionMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { LegendItemBadgeShape } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class AnnotationLayerProxy extends Base implements IAnnotationLayerProxy {
    static $t: Type;
    private _container;
    get container(): any;
    set container(a: any);
    matchesType(a: Series): boolean;
    createCrosshairLayer(): any;
    createValueLayer(): any;
    createCalloutLayer(): any;
    createFinalValueLayer(): any;
    setCrosshairHorizontalLineVisibility(a: Series, b: Visibility): void;
    setCrosshairVerticalLineVisibility(a: Series, b: Visibility): void;
    setCrosshairHorizontalLineStroke(a: Series, b: Brush): void;
    setCrosshairVerticalLineStroke(a: Series, b: Brush): void;
    setCrosshairXAxisForeground(a: Series, b: Brush): void;
    setCrosshairYAxisForeground(a: Series, b: Brush): void;
    setCrosshairXAxisBackground(a: Series, b: Brush): void;
    setCrosshairYAxisBackground(a: Series, b: Brush): void;
    setCrosshairYAxisPrecision(a: Series, b: number): void;
    setCrosshairXAxisPrecision(a: Series, b: number): void;
    setCrosshairOnAxesEnabled(a: Series, b: boolean): void;
    setCrosshairUseInterpolation(a: Series, b: boolean): void;
    setCrosshairThickness(a: Series, b: number): void;
    isCrosshairLayer(a: Series): boolean;
    setFinalValuePrecision(a: Series, b: number): void;
    setFinalValueBackground(a: Series, b: Brush): void;
    setFinalValueForeground(a: Series, b: Brush): void;
    setContentMemberPath(a: Series, b: string): void;
    setCalloutsAllowedPositions(a: Series, b: CalloutPlacementPositionsCollection): void;
    setLabelMemberPath(a: Series, b: string): void;
    setXMemberPath(a: Series, b: string): void;
    setYMemberPath(a: Series, b: string): void;
    setTargetSeries(a: Series, b: Series): void;
    setCollisionChannel(a: Series, b: string): void;
    setIsAutoCalloutBehaviorEnabled(a: Series, b: boolean): void;
    setGreedyCollisionMode(a: Series, b: boolean): void;
    setCollisionMode(a: Series, b: CalloutCollisionMode): void;
    setUseItemColorForFill(a: Series, b: boolean): void;
    setUseItemColorForOutline(a: Series, b: boolean): void;
    setCalloutStrokeThickness(a: Series, b: number): void;
    setUseAutoContrastingLabelColors(a: Series, b: boolean): void;
    setCalloutBackground(a: Series, b: Brush): void;
    setCalloutTextStyle(a: Series, b: FontInfo): void;
    setAutoCalloutLabelPrecision(a: Series, b: number): void;
    setCalloutLightColor(a: Series, b: Brush): void;
    setCalloutDarkColor(a: Series, b: Brush): void;
    setCalloutOutline(a: Series, b: Brush): void;
    setCalloutLeaderBrush(a: Series, b: Brush): void;
    setCalloutTextColor(a: Series, b: Brush): void;
    setShouldTruncateOnBoundaryCollisions(a: Series, b: boolean): void;
    setUseDedicatedLanes(a: Series, b: boolean): void;
    isCalloutLayer(a: Series): boolean;
    isDataToolTipLayer(a: Series): boolean;
    isFinalValueLayer(a: Series): boolean;
    addCalloutStyleUpdating(a: Series, b: (sender: any, args: CalloutStyleUpdatingEventArgs) => void): void;
    removeCalloutStyleUpdating(a: Series, b: (sender: any, args: CalloutStyleUpdatingEventArgs) => void): void;
    addCalloutRenderStyleUpdating(a: Series, b: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void): void;
    removeCalloutRenderStyleUpdating(a: Series, b: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void): void;
    setCalloutStyleUpdatingEventEnabled(a: Series, b: boolean): void;
    setUseValueForAutoCalloutLabels(a: Series, b: boolean): void;
    setCalloutRenderStyleUpdatingEventEnabled(a: Series, b: boolean): void;
    updateDataToolTipPropertyByName(a: Series, b: string, c: any): void;
    getIsAutoCalloutBehaviorEnabled(a: Series): boolean;
    setValueMode(a: Series, b: ValueLayerValueMode): void;
    setUseLegend(a: Series, b: boolean): void;
    setTitle(a: Series, b: string): void;
    setLegendItemBadgeShape(a: Series, b: LegendItemBadgeShape): void;
    setValueAxisAnnotationEnabled(a: Series, b: boolean): void;
    getValueMode(a: Series): ValueLayerValueMode;
    isValueLayer(a: Series): boolean;
    setBrush(a: Series, b: Brush): void;
    setDashArray(a: Series, b: number[]): void;
}
