import { Type } from "igniteui-react-core";
/**
 * An enum representing the available display modes of crosshairs lines in the chart.
 */
export declare enum CrosshairsDisplayMode {
    /**
     * Display crosshair lines depending on chart type, e.g. no vertical crosshair lines for column and waterfall charts.
     */
    Auto = 0,
    /**
     * Display no crosshair lines in the chart.
     */
    None = 1,
    /**
     * Display horizontal line of crosshairs in the chart.
     */
    Horizontal = 2,
    /**
     * Display vertical line of crosshairs in the chart.
     */
    Vertical = 3,
    /**
     * Display both horizontal and vertical lines of crosshairs in the chart.
     */
    Both = 4
}
/**
 * @hidden
 */
export declare let CrosshairsDisplayMode_$type: Type;
