import { Type } from "igniteui-react-core";
/**
 * Describes available positions to anchor the pointer to the PointerTooltip.
 */
export declare enum PointerTooltipPointerLocation {
    /**
     * The anchor is decided automatically.
     */
    Auto = 0,
    /**
     * The anchor is top left of the content.
     */
    TopLeft = 1,
    /**
     * The anchor is top left of the content.
     */
    TopMiddle = 2,
    /**
     * The anchor is top left of the content.
     */
    TopRight = 3,
    /**
     * The anchor is top left of the content.
     */
    RightTop = 4,
    /**
     * The anchor is top left of the content.
     */
    RightMiddle = 5,
    /**
     * The anchor is top left of the content.
     */
    RightBottom = 6,
    /**
     * The anchor is top left of the content.
     */
    BottomRight = 7,
    /**
     * The anchor is top left of the content.
     */
    BottomMiddle = 8,
    /**
     * The anchor is top left of the content.
     */
    BottomLeft = 9,
    /**
     * The anchor is top left of the content.
     */
    LeftBottom = 10,
    /**
     * The anchor is top left of the content.
     */
    LeftMiddle = 11,
    /**
     * The anchor is top left of the content.
     */
    LeftTop = 12
}
/**
 * @hidden
 */
export declare let PointerTooltipPointerLocation_$type: Type;
