import { Type } from "igniteui-react-core";
/**
 * Describes the Selection mode to use for the series in the chart.
 */
export declare enum SeriesSelectionBehavior {
    /**
     * Selection behavior is determined by the component.
     */
    Auto = 0,
    /**
     * Selection is per data item, multiple data items can be selected.
     */
    PerDataItemMultiSelect = 1,
    /**
     * Selection is per data item, only one data item can be selected at once.
     */
    PerDataItemSingleSelect = 2,
    /**
     * Selection is per series and data item, multiple data items can be selected per series at once.
     */
    PerSeriesAndDataItemMultiSelect = 3,
    /**
     * Selection is per series and data item, only one data item may be selected per series at once.
     */
    PerSeriesAndDataItemSingleSelect = 4,
    /**
     * Selection is per series and data item, only one item may be selected globally at once.
     */
    PerSeriesAndDataItemGlobalSingleSelect = 5,
    /**
     * Selection is per series, multiple entire series may be selected at once.
     */
    PerSeriesMultiSelect = 6,
    /**
     * Selection is per series, only one series may be selected at once.
     */
    PerSeriesSingleSelect = 7
}
/**
 * @hidden
 */
export declare let SeriesSelectionBehavior_$type: Type;
