import { IgrSeries } from "./igr-series";
import { IgrSeriesViewer } from "./igr-series-viewer";
import { ChartCursorEventArgs as ChartCursorEventArgs_internal } from "./ChartCursorEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export declare class IgrChartCursorEventArgs {
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ChartCursorEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item(): any;
    set item(v: any);
    /**
     * Gets the series associated with the current event.
    */
    get series(): IgrSeries;
    set series(v: IgrSeries);
    /**
     * Gets the Chart associated with the current event.
    */
    get seriesViewer(): IgrSeriesViewer;
    set seriesViewer(v: IgrSeriesViewer);
    /**
     * Provides a human readable expresion of the event arguments.
    
    */
    toString(): string;
}
