import { IgrSeries } from "./igr-series";
import { IgrSeriesMatcher } from "./igr-series-matcher";
import { ChartSelection as ChartSelection_internal } from "./ChartSelection";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents a selected item within the chart. This should be treated as immutable while in the selected items collection. Changes while part of the collection will not be respected.
*/
export declare class IgrChartSelection {
    protected createImplementation(): ChartSelection_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ChartSelection_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get item(): any;
    set item(v: any);
    get series(): IgrSeries;
    set series(v: IgrSeries);
    /**
     * If set, allows for selecting a series based on a matcher. This should resolve to a single static series at the time that the chart selection is added to selected items.
     * It will not be re-evaluated while the ChartSelection is in the selected items.
    */
    get matcher(): IgrSeriesMatcher;
    set matcher(v: IgrSeriesMatcher);
    findByName(name: string): any;
    equals(other: any): boolean;
    getHashCode(): number;
}
