import { IgrChartSortDescription } from "./igr-chart-sort-description";
import { ChartSortDescriptionCollection as ChartSortDescriptionCollection_internal } from "./ChartSortDescriptionCollection";
/**
 * Represents a collection of sort elements that are applied to a data source or provider.
*/
export declare class IgrChartSortDescriptionCollection {
    protected createImplementation(): ChartSortDescriptionCollection_internal;
    protected _implementation: any;
    get i(): ChartSortDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgrChartSortDescription): IgrChartSortDescription;
    get count(): number;
    toArray(): IgrChartSortDescription[];
    [Symbol.iterator](): Generator<any, void, unknown>;
    /**
 * Gets or sets whether this collection should detach the sync when the target collection changes.
*/
    get shouldDetachOnTargetChange(): boolean;
    set shouldDetachOnTargetChange(v: boolean);
    findByName(name: string): any;
    add(item: IgrChartSortDescription): boolean;
    insert(index: number, item: IgrChartSortDescription): void;
    clear(): void;
    indexOf(item: IgrChartSortDescription): number;
    remove(item: IgrChartSortDescription): boolean;
    removeAt(index: number): IgrChartSortDescription;
}
