import * as React from 'react';
import { ContourValueResolver } from "./ContourValueResolver";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Class used to determine the numeric values of contour lines, given a larger list of numeric values.
*/
export declare abstract class IgrContourValueResolver<P extends IIgrContourValueResolverProps = IIgrContourValueResolverProps> extends React.Component<P, {}> {
    protected createImplementation(): ContourValueResolver;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ContourValueResolver; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrContourValueResolver;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrContourValueResolverProps {
    children?: React.ReactNode;
}
