import { IgrHorizontalStackedSeriesBase, IIgrHorizontalStackedSeriesBaseProps } from "./igr-horizontal-stacked-series-base";
import { StackedColumnSeries } from "./StackedColumnSeries";
/**
 * Represents a IgxDataChartComponent stacked column series.
*/
export declare class IgrStackedColumnSeries<P extends IIgrStackedColumnSeriesProps = IIgrStackedColumnSeriesProps> extends IgrHorizontalStackedSeriesBase<P> {
    protected createImplementation(): StackedColumnSeries;
    /**
                                 * @hidden
                                 */
    get i(): StackedColumnSeries;
    constructor(props: P);
    /**
     * Gets whether the current series shows a column shape.
    */
    get isColumn(): boolean;
    /**
     * Overridden by derived series classes to indicate when marker-less display is preferred or not.
    */
    get isMarkerlessDisplayPreferred(): boolean;
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX(): number;
    set radiusX(v: number);
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY(): number;
    set radiusY(v: number);
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan(): number;
}
export interface IIgrStackedColumnSeriesProps extends IIgrHorizontalStackedSeriesBaseProps {
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    radiusX?: number | string;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    radiusY?: number | string;
}
