import { TreemapNodeStyleMappingTargetType } from "./TreemapNodeStyleMappingTargetType";
import { TreemapValueMappingMode } from "./TreemapValueMappingMode";
import { IgrTreemapNodeStyle, IIgrTreemapNodeStyleProps } from "./igr-treemap-node-style";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
export declare class IgrTreemapNodeStyleMapping extends IgrTreemapNodeStyle<IIgrTreemapNodeStyleMappingProps> {
    protected createImplementation(): TreemapNodeStyleMapping;
    /**
                                 * @hidden
                                 */
    get i(): TreemapNodeStyleMapping;
    constructor(props: IIgrTreemapNodeStyleMappingProps);
    /**
     * Gets or sets the unique name of the mapping.
    */
    get targetType(): TreemapNodeStyleMappingTargetType;
    set targetType(v: TreemapNodeStyleMappingTargetType);
    /**
     * Gets or sets the unique name of the mapping.
    */
    get name(): string;
    set name(v: string);
    /**
     * Gets or sets the minimum value to which the mapping applies.
    */
    get minimumValue(): number;
    set minimumValue(v: number);
    /**
     * Gets or sets the maximum value to which the mapping applies.
    */
    get maximumValue(): number;
    set maximumValue(v: number);
    /**
     * Gets or sets the value to which the mapping applies.
    */
    get value(): any;
    set value(v: any);
    /**
     * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
    */
    get mappingMode(): TreemapValueMappingMode;
    set mappingMode(v: TreemapValueMappingMode);
}
export interface IIgrTreemapNodeStyleMappingProps extends IIgrTreemapNodeStyleProps {
    /**
     * Gets or sets the unique name of the mapping.
    */
    targetType?: TreemapNodeStyleMappingTargetType | string;
    /**
     * Gets or sets the unique name of the mapping.
    */
    name?: string;
    /**
     * Gets or sets the minimum value to which the mapping applies.
    */
    minimumValue?: number | string;
    /**
     * Gets or sets the maximum value to which the mapping applies.
    */
    maximumValue?: number | string;
    /**
     * Gets or sets the value to which the mapping applies.
    */
    value?: any;
    /**
     * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
    */
    mappingMode?: TreemapValueMappingMode | string;
}
